#include "stdlib.h"
#include "stdio.h"
#include "string.h"

// gcc -o checksum.exe checksum.c :-> con esto compilas

void checksumdata(FILE *file);
int leerKey(FILE *result);
void printkey(FILE *file);

char skey[6];


void checksumdata(FILE *file)
{
	fseek(file,0x3E7FC*sizeof(char),SEEK_SET);
	fread(skey,sizeof(char),4,file);
    skey[4]=0;
    fclose(file);
    //fclose(result);
}

int leerKey(FILE *result){
    unsigned char c;
    while(!feof(result)){
                         fscanf(result,"%c",&c);
                         printf("%c",c);
                         }
    printf("\n");
    return 1;
}

void printkey(FILE *key) {
    int i;
    
    if (skey[0] != 0 || skey[1] != 0) {
        for(i=0; i<4; i++) {
            printf("%02X ", (unsigned char) skey[i]);
            fprintf(key, "%02X", (unsigned char) skey[i]);
        }
        puts("\n");
    }
    fputs("\n", key);
}

int main(int argc, char *argv[])
{

    FILE *file, *key;
	char *name;
	int n,m;
   
   /* comentarios:
   argc contiene el numero de parametros que se pasan desde la linea de comandos
   argv[0]-> contiene el nombre del ejecutable con el path
   argv[1]-> contiene el nombre del fichero del firmware
   argv[2]-> parametro opcional, "-r" hace que se abra una lista nueva "checksum.txt"
   */


   // seccion de codigo que devuelve el nombre del ejecutable sin el path
   name=(char *) argv[0];
   m=0;
   n=0;
   while(name[n]!=0)
	{
	if(name[n]==':' || name[n]=='\\' || name[n]=='/') m=n+1; // la ruta puede ser "C:\dir\ejecutable.exe"
	n++;
	}
   name=&name[m]; // aqui empieza el nombre del ejecutable (tomando el ejemplo anterior, "ejecutable.exe"


   if(argc<2) {printf("formato: %s fichero <-r>\n\n",name);
               printf("Parametros:\n");
			   printf("	-r : Crea un nuevo fichero de checksums\n");
			   printf("\n");
              return -1;}
   file=fopen(argv[1], "rb");  
   if(file==NULL) {
				   printf("No se pudo abrir: %s\n\n",argv[1]);return -1;
				   }
    key=NULL;

    if(argc>2) 
	{
	if(!strcmp(argv[2],"-r")) // compara si hemos aadido el parametro -r como segundo argumento
	   key=fopen("checksum.txt", "wt"); // crea un nuevo checksum.txt
	}
	
	if(!key) key=fopen("checksum.txt", "at");     // abre para aadir datos si no se abri como fichero nuevo
	if(key==NULL) {
				   printf("No se pudo abrir: checksum.txt\n\n");
				   fclose(file);
				   return -1;
				   }
	fprintf(key,"Checksum en %s:\n",argv[1]);
	checksumdata(file);
	printkey(key);
	fputs("\n", key);
	fclose(key);
	return(0);
}
